/*
	some useful defs for STM32
	gbm 11'2015
*/
#ifndef STM32UTIL_H
#define STM32UTIL_H

#define WEAK __attribute__ ((weak))
// bit fields to be ORed
#define BF2(b,v)	((uint32_t)(v) << ((b & 0xf) * 2))
#define BF3(b,v)	((uint32_t)(v) << ((b % 10) * 3))
#define BF4(b,v)	((uint32_t)(v) << ((b & 7) * 4))
#define BF5(b,v)	((uint32_t)(v) << ((b % 6) * 5))
#define BF8(b,v)	((uint32_t)(v) << ((b & 3) * 8))
// bit fields to be ANDed (for STM32L series MODER)
#define BF2A(b,v)	((uint32_t)(v) << ((b & 0xf) * 2) | ~(3u << ((b & 0xf) * 2)))
//========================================================================
typedef __IO uint32_t * __IO32p;	// short type name
//========================================================================
// register init structure and routine
struct init_entry_ {
	volatile uint32_t *loc;
	uint32_t value;
};

static __INLINE void writeregs(const struct init_entry_ *p)
{
	for (; p->loc; p ++)
		*p->loc = p->value;
}
//========================================================================
#endif
